'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _kbpgp = require('kbpgp');

var _kbpgp2 = _interopRequireDefault(_kbpgp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var importFromArmoredPgp = _bluebird2.default.promisify(_kbpgp2.default.KeyManager.import_from_armored_pgp);
var unbox = _bluebird2.default.promisify(_kbpgp2.default.unbox);

module.exports = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(publicKey, message) {
    var keyManager, fingerprint, ring, literal, signer, signerKeyManager, signatureFingerprint;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return importFromArmoredPgp({ armored: publicKey }).then(function (keyManager) {
              return keyManager;
            });

          case 3:
            keyManager = _context.sent;
            fingerprint = keyManager.get_pgp_fingerprint_str();
            ring = new _kbpgp2.default.keyring.KeyRing();


            ring.add_key_manager(keyManager);

            _context.next = 9;
            return unbox({ keyfetch: ring, armored: message }).then(function (literals) {
              return literals.shift();
            });

          case 9:
            literal = _context.sent;


            // @TODO: Signer might be empty. Detect and fail gracefully
            signer = literal.get_data_signer();
            signerKeyManager = signer.get_key_manager();
            signatureFingerprint = signerKeyManager.get_pgp_fingerprint_str();
            return _context.abrupt('return', _promise2.default.resolve(fingerprint === signatureFingerprint));

          case 16:
            _context.prev = 16;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', _promise2.default.reject(_context.t0));

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 16]]);
  }));

  function verify(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return verify;
}();